org.apache.commons.math.optimization

## Class SimpleScalarValueChecker

- java.lang.Object
- - org.apache.commons.math.optimization.SimpleScalarValueChecker

- All Implemented Interfaces:
    RealConvergenceChecker

      public class SimpleScalarValueChecker
      extends java.lang.Object
      implements RealConvergenceChecker

  Simple implementation of the `RealConvergenceChecker` interface using only objective function values.

  Convergence is considered to have been reached if either the relative difference between the objective function values is smaller than a threshold or if either the absolute difference between the objective function values is smaller than another threshold.

  Since:
    2.0
  Version:
    $Revision: 990655 $ $Date: 2010-08-29 23:49:40 +0200 (dim. 29 août 2010) $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private double` | `absoluteThreshold` Absolute tolerance threshold.
    `private static double` | `DEFAULT_ABSOLUTE_THRESHOLD` Default absolute threshold.
    `private static double` | `DEFAULT_RELATIVE_THRESHOLD` Default relative threshold.
    `private double` | `relativeThreshold` Relative tolerance threshold.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleScalarValueChecker()` Build an instance with default threshold.
    `SimpleScalarValueChecker(double relativeThreshold, double absoluteThreshold)` Build an instance with a specified threshold.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `converged(int iteration, RealPointValuePair previous, RealPointValuePair current)` Check if the optimization algorithm has converged considering the last points.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_RELATIVE_THRESHOLD

          private static final double DEFAULT_RELATIVE_THRESHOLD

      Default relative threshold.
      See Also:
        Constant Field Values

    - #### DEFAULT_ABSOLUTE_THRESHOLD

          private static final double DEFAULT_ABSOLUTE_THRESHOLD

      Default absolute threshold.
      See Also:
        Constant Field Values

    - #### relativeThreshold

          private final double relativeThreshold

      Relative tolerance threshold.

    - #### absoluteThreshold

          private final double absoluteThreshold

      Absolute tolerance threshold.

  - ### Constructor Detail

    - #### SimpleScalarValueChecker

          public SimpleScalarValueChecker()

      Build an instance with default threshold.

    - #### SimpleScalarValueChecker

          public SimpleScalarValueChecker(double relativeThreshold,
                                  double absoluteThreshold)

      Build an instance with a specified threshold.

      In order to perform only relative checks, the absolute tolerance must be set to a negative value. In order to perform only absolute checks, the relative tolerance must be set to a negative value.

      Parameters:
        `relativeThreshold` - relative tolerance threshold
        `absoluteThreshold` - absolute tolerance threshold

  - ### Method Detail

    - #### converged

          public boolean converged(int iteration,
                          RealPointValuePair previous,
                          RealPointValuePair current)

      Check if the optimization algorithm has converged considering the last points.

      This method may be called several time from the same algorithm iteration with different points. This can be detected by checking the iteration number at each call if needed. Each time this method is called, the previous and current point correspond to points with the same role at each iteration, so they can be compared. As an example, simplex-based algorithms call this method for all points of the simplex, not only for the best or worst ones.

      Specified by:
        `converged` in interface `RealConvergenceChecker`
      Parameters:
        `iteration` - index of current iteration
        `previous` - point from previous iteration
        `current` - point from current iteration
      Returns:
        true if the algorithm is considered to have converged

Copyright (c) 2003-2013 Apache Software Foundation